;*******************************************************************************
;
; CONFIGURATION PARAMETERS for 18F1X20 
;
;*******************************************************************************

	__CONFIG  _CONFIG1H, _IESO_OFF_1H & _FSCM_OFF_1H & _INTIO2_OSC_1H

	__CONFIG  _CONFIG2L, _BOR_ON_2L & _PWRT_ON_2L

	__CONFIG  _CONFIG2H, _WDT_OFF_2H

	__CONFIG  _CONFIG3H, _MCLRE_ON_3H

	__CONFIG  _CONFIG4L, _DEBUG_OFF_4L & _LVP_OFF_4L & _STVR_ON_4L

	__CONFIG  _CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L

	__CONFIG  _CONFIG5H, _CPB_OFF_5H & _CPD_OFF_5H

	__CONFIG  _CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L

	__CONFIG  _CONFIG6H, _WRTC_OFF_6H & _WRTB_OFF_6H & _WRTD_OFF_6H

	__CONFIG  _CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L

	__CONFIG  _CONFIG7H, _EBTRB_OFF_7H


;==========================================================================
;==========================================================================
;
; CONFIGURATION BITS DETAILS
;
;==========================================================================
;==========================================================================

;=======================================================================
;
;       Configuration Bits
;

;_CONFIG1H       EQU    H'300001'
;_CONFIG2L       EQU    H'300002'
;_CONFIG2H       EQU    H'300003'
;_CONFIG3H       EQU    H'300005'
;_CONFIG4L       EQU    H'300006'
;_CONFIG5L       EQU    H'300008'
;_CONFIG5H       EQU    H'300009'
;_CONFIG6L       EQU    H'30000A'
;_CONFIG6H       EQU    H'30000B'
;_CONFIG7L       EQU    H'30000C'
;_CONFIG7H       EQU    H'30000D'


;Configuration Byte 1H Options
;_IESO_ON_1H       EQU  H'FF' ; Internal External Oscillator Switch Over mode enabled
;_IESO_OFF_1H      EQU  H'7F' ; Internal External Oscillator Switch Over mode disabled
;_FSCM_ON_1H       EQU  H'FF' ; Fail Safe Clock Monitor enabled
;_FSCM_OFF_1H      EQU  H'BF' ; Fail Safe Clock Monitor disabled
;_RC_OSC_1H        EQU  H'FF' ; External RC on OSC1, OSC2 as Fosc/4
;_RCIO_OSC_1H      EQU  H'F7' ; External RC on OSC1, OSC2 as RA6
;_LP_OSC_1H        EQU  H'F0' ; LP Oscillator
;_XT_OSC_1H        EQU  H'F1' ; XT Oscillator
;_HS_OSC_1H        EQU  H'F2' ; HS Oscillator
;_HSPLL_OSC_1H     EQU  H'F6' ; HS + PLL
;_EC_OSC_1H        EQU  H'F4' ; External Clock on OSC1, OSC2 as Fosc/4
;_ECIO_OSC_1H      EQU  H'F5' ; External Clock on OSC1, OSC2 as RA6
;_INTIO1_OSC_1H    EQU  H'F9' ; Internal RC, OSC1 as RA7, OSC2 as Fosc/4
;_INTIO2_OSC_1H    EQU  H'F8' ; Internal RC, OSC1 as RA7, OSC2 as RA6

;Configuration Byte 2L Options
;_BORV_20_2L       EQU  H'FF' ; BOR Voltage - 2.0v
;_BORV_27_2L       EQU  H'FB' ;               2.7v
;_BORV_42_2L       EQU  H'F7' ;               4.2v
;_BORV_45_2L       EQU  H'F3' ;               4.5v
;_BOR_ON_2L        EQU  H'FF' ; Brown-Out Reset enabled
;_BOR_OFF_2L       EQU  H'FD' ; Brown-Out Reset disabled
;_PWRT_OFF_2L      EQU  H'FF' ; Power-Up Timer disabled
;_PWRT_ON_2L       EQU  H'FE' ; Power-Up Timer enabled

;Configuration Byte 2H Options
;_WDT_ON_2H        EQU  H'FF' ; Watch Dog Timer enabled
;_WDT_OFF_2H       EQU  H'FE' ; Watch Dog Timer disabled
;_WDTPS_32K_2H     EQU  H'FF' ;   1:32,768    WDT Postscaler ratio
;_WDTPS_16K_2H     EQU  H'FD' ;   1:16,384
;_WDTPS_8K_2H      EQU  H'FB' ;   1: 8,192
;_WDTPS_4K_2H      EQU  H'F9' ;   1: 4,096
;_WDTPS_2K_2H      EQU  H'F7' ;   1: 2,048
;_WDTPS_1K_2H      EQU  H'F5' ;   1: 1,024
;_WDTPS_512_2H     EQU  H'F3' ;   1:   512
;_WDTPS_256_2H     EQU  H'F1' ;   1:   256
;_WDTPS_128_2H     EQU  H'EF' ;   1:   128
;_WDTPS_64_2H      EQU  H'ED' ;   1:    64
;_WDTPS_32_2H      EQU  H'EB' ;   1:    32
;_WDTPS_16_2H      EQU  H'E9' ;   1:    16
;_WDTPS_8_2H       EQU  H'E7' ;   1:     8
;_WDTPS_4_2H       EQU  H'E5' ;   1:     4
;_WDTPS_2_2H       EQU  H'E3' ;   1:     2
;_WDTPS_1_2H       EQU  H'E1' ;   1:     1

;Configuration Byte 3H Options
;_MCLRE_ON_3H      EQU  H'FF' ; MCLR enabled, RA5 input disabled
;_MCLRE_OFF_3H     EQU  H'7F' ; MCLR disabled, RA5 input enabled

;Configuration Byte 4L Options
;_DEBUG_ON_4L      EQU  H'7F' ; BacKground deBUGger enabled
;_DEBUG_OFF_4L     EQU  H'FF' ; BacKground deBUGger disabled
;_LVP_ON_4L        EQU  H'FF' ; Low Voltage Prgramming enabled
;_LVP_OFF_4L       EQU  H'FB' ; Low Voltage Prgramming disabled
;_STVR_ON_4L       EQU  H'FF' ; Stack over/underflow Reset enabled
;_STVR_OFF_4L      EQU  H'FE' ; Stack over/underflow Reset disabled

;Configuration Byte 5L Options
; Protect program memory blocks from programmer reads and writes (see Config Byte 6L)
;_CP0_ON_5L        EQU  H'FE' ; Block 0 protected
;_CP0_OFF_5L       EQU  H'FF' ; Block 0 readable/ may be writable
;_CP1_ON_5L        EQU  H'FD' ; Block 1 protected
;_CP1_OFF_5L       EQU  H'FF' ; Block 1 readable/ may be writable

;Configuration Byte 5H Options
; Protect blocks from programmer reads and writes (see Config Byte 6H)
;_CPB_ON_5H        EQU  H'BF' ; Boot Block protected
;_CPB_OFF_5H       EQU  H'FF' ; Boot Block readable / may be writable
;_CPD_ON_5H        EQU  H'7F' ; Data EE memory protected
;_CPD_OFF_5H       EQU  H'FF' ; Data EE memory readable / may be writable

;Configuration Byte 6L Options
; Protect program memory blocks from table writes and programmer writes
;_WRT0_ON_6L       EQU  H'FE' ; Block 0 write protected
;_WRT0_OFF_6L      EQU  H'FF' ; Block 0 writable
;_WRT1_ON_6L       EQU  H'FD' ; Block 1 write protected
;_WRT1_OFF_6L      EQU  H'FF' ; Block 1 writable

;Configuration Byte 6H Options
; Protect blocks from table writes and programmer writes
;_WRTC_ON_6H       EQU  H'DF' ; Config registers write protected
;_WRTC_OFF_6H      EQU  H'FF' ; Config registers writable
;_WRTB_ON_6H       EQU  H'BF' ; Boot block write protected
;_WRTB_OFF_6H      EQU  H'FF' ; Boot block writable
;_WRTD_ON_6H       EQU  H'7F' ; Data EE write protected
;_WRTD_OFF_6H      EQU  H'FF' ; Data EE writable

;Configuration Byte 7L Options
; Protect program memory blocks from table reads executed from other blocks
;_EBTR0_ON_7L      EQU  H'FE' ; Block 0 protected
;_EBTR0_OFF_7L     EQU  H'FF' ; Block 0 readable
;_EBTR1_ON_7L      EQU  H'FD' ; Block 1 protected
;_EBTR1_OFF_7L     EQU  H'FF' ; Block 1 readable

;Configuration Byte 7H Options
; Protect block from table reads executed in other blocks
;_EBTRB_ON_7H      EQU  H'BF' ; Boot block read protected
;_EBTRB_OFF_7H     EQU  H'FF' ; Boot block readable
