;***************************************************************************
;
; SPECIFICHE PIC 18F1X20
; PER UTILIZZARLE BISOGNA 	INCLUDERE IL FILE ALL'INIZIO (PRIMA DI USARE LA MACRO)
; 				SETTARE LE PERIFERICHE DI INTERESSE
;				CANCELLARE QUELLE CHE NON INTERESSANO
;				CHIAMARE LA MACRO DEV_SETTING
;
;***************************************************************************

DEV_SETTING	MACRO	

	;***********************;;
	; RS232 SETTING		;;
	;***********************;;
	BCF	TRISB, TX	;; Setto I/O per la seriale
	BSF	TRISB, RX	;; 
				;;
	MOVLW   D'51'           ;; 9.6 KBaud/s A 8 MHz di clock
	MOVWF   SPBRG           ;; SETTAGGIO REGISTRO BAUD RATE
	MOVLW   B'00100100'     ;;
	MOVWF   TXSTA           ;; SETTING REG TRASMISSIONE (8bit, no parity)
	BSF     INTCON, PEIE    ;; ATTIVO INTERRUPT PERIFERICI
 				;;
	MOVLW   B'00010000'     ;;
	MOVWF   RCSTA           ;; setting PARAMETRI di ricezione (Continous RX, ...)	
	BSF     RCSTA,SPEN      ;; RX/TX MODULE ACTIVED
	CLRF    RCREG		;;
	BSF	PIE1, RCIE	;; interrupt di arrivo byte seriale
	;***********************;;


	;***********************;;
	; COMPARE (2) SETTING 	;; MODULE COMPARE CHE MI RICHIAMA UN INTERRUPT OGNI 100 ms (A 16 MHz)
	;***********************;;
;	MOVLW	B'00111000'	;; Two 8bit operation, T3 Clk for CCP2, Presc. 1:8, Internal Clock
;	MOVWF	T3CON		;; TIMER3 ALL'INIZIO  SPENTO !!!!!!!! 
				;;
;	MOVLW	B'01010000'	;; Setto il compare ... ogni 50.000 cicli
;	MOVWF	CCPR2L		;; che a 16 MHz (4 MPs) e con presc. di 8 da' esattamente 100 ms
;	MOVLW	B'11000011'	;;
;	MOVWF	CCPR2H		;;
				;;
;	MOVLW	B'00001011'	;; Compare Mode Setting: Trigger special event (reset timer, int, A/D start)
;	MOVWF	CCP2CON		;; 
				;;
;	BCF	PIR2, CCP2IF	;;
;	BSF	PIE2, CCP2IE	;; SETTING INTERRUPT
;	BSF	T3CON, TMR3ON	;; START TIMER3
	;***********************;;

	;***********************;;
	; ADC SETTING		;;
	;***********************;;
;	MOVLW   B'10001110'	;; SETTING PORTE An & Dig: RA0 = An, OTHER ALL = Dig; R justified; 32Tosc
;	MOVWF   ADCON1  	;;
;	MOVLW	B'10000000'	;; INIZIALIZZAZIONE A/D: 32Tosc, Channel 0, A/D MODULE OFF
;	MOVWF	ADCON0		;;
;	BSF	ADCON0, 0	;; A/D MODULE ON
	;***********************;;



ENDM

