
;*******************************************************************************;
;										;
;     IN QUESTO FILE SONO RACCOLTE TUTTE MACRO PER I PIC18Fxx2 E PIC18Fxx8	;
;     V 1.2 					     (ultimo agg. 04/02/04)	;
;										;
;     MODIFICATO LA MACRO PER I MICROSECONDI!!!					;
;     MODIFICARE LA MACRO PER I MILLISECONDI!!!					;
;*******************************************************************************;



;-------------------------------------------------------------------------------;
;	MACRO CHE COPIA IL VALORE DI UN BIT DA UN REGISTO AD UN'ALTRO		;
;       Timing:  4 clks								;
;       PM: 4            							;
;-------------------------------------------------------------------------------;
Bit_To_Bit	MACRO	argom1, argbit1, argom2, argbit2			;
										;
		BTFSS	argom1, argbit1 					;
		BCF	argom2, argbit2						;
		BTFSC	argom1, argbit1 					;
		BSF	argom2, argbit2						;
		ENDM								;
;-------------------------------------------------------------------------------;
;-------------------------------------------------------------------------------;
;	LITTERAL IN F								;
;       Timing:  2 clks								;
;       PM: 2            							;
;-------------------------------------------------------------------------------;
MOVLF	MACRO	lettera, registro						;
										;
		MOVLW	lettera							;
		MOVWF	registro						;
		ENDM								;
;-------------------------------------------------------------------------------;



;*******************************************************************************;
;										;
;	MACRO CHE SETTANO IL PUNTATORE PER LA LETTURA DELLE TABELLE		;
;										;
;		Setta il puntatore in cima alla tabella				;
;	USO:	TabSetting	<LabelTable>					;
;										;
;		Aggiunge W al puntatore di base (a 21 bit) della tabella	;
;	USO:	AddTab								;
;										;
;		Aggiunge W * Num al puntatore di base (a 21 bit) della tabella	;
;	USO:	AddMulTab	< Num >						;
;										;
;		Setta il puntatore all'elemento <index> della tabella		;
;	USO:	TabSetpoint	<LabelTable>, <Index>				;
;										;
;*******************************************************************************;
;	

TabSetting	MACRO	TablePointer
		MOVLW	low	TablePointer
		MOVWF	TBLPTRL
		MOVLW	high	TablePointer	
		MOVWF	TBLPTRH
		MOVLW	upper	TablePointer	
		MOVWF	TBLPTRU
		ENDM

AddTab		MACRO
		ADDWF	TBLPTRL, F		;
		MOVLW	.0			;
		ADDWFC	TBLPTRH, F		;
		ADDWFC	TBLPTRU, F		;
		ENDM	

AddMulTab	MACRO	Mult			;
		MULLW	Mult			;
		MOVF	PRODL, W		;
		ADDWF	TBLPTRL, F		;
		MOVF	PRODH, W		;
		ADDWFC	TBLPTRH, F		;
		MOVLW	.0			;
		ADDWFC	TBLPTRU, F		;
		ENDM		
		
TabSetpoint	MACRO	TablePointer, Index
		MOVLW	upper	TablePointer + Index	
		MOVWF	TBLPTRU
		MOVLW	high	TablePointer + Index	
		MOVWF	TBLPTRH
		MOVLW	low	TablePointer + Index
		ENDM


;*******************************************************************************;
;										;
;	MACRO CHE PRODUCONO UN'ATTESA DI UN NUMERO PRESTABILITO DI us, ms o s	;
;										;
;	Affinch la macro funzioni bene deve essere definita la frequenza	;
;	di lavoro del perocessore nel main program tramite l'istruzione:	;
;										;
;	#define FREQUENCY <Frequenza>	; Frequenza del procesore in KHz 	;
;					(va considerato anche l'eventuale PLL)	;
;	Se nessuna frequenza e' definita la macro di default utilizza 16 MHz	;
;										;
;	USO:	DelayMicroSec	< N >						;
;		Provoca un attesa di N microsecondi (fino a 25599 us a 16 MHz)	;
;	Precisione tipica 1% con delay > 10 us - 0.25us con delay < 10 us	;
;										;
;	USO:	DelayMilliSec	< N >						;
;		Provoca un attesa di N millisecondi (fino a 25599 ms a 16 MHz)	;
;	Precisione tipica 0.1% 							;
;										;
;	CON 	N > 0								;
;*******************************************************************************;


DelayMicroSec	macro	Time

		ifdef	FREQUENCY
		Microsecondi = ((Time * FREQUENCY)/D'16000')
		endif

		if Microsecondi > D'100'
		PUSH
		MOVLW	Microsecondi / D'100'		
		MOVWF	TOSL	
		MOVLW	D'100'	;<--------------------------------------;
		CLRWDT		;<------------------------------;	;
		DECFSZ	WREG					;	;
		DB	0xFD,0xD7 ;BRA	-3	;---------------;	;
		DECFSZ	TOSL						;
		DB	0xFA,0xD7 ;BRA	-6	;-----------------------;
		MOVLW	Microsecondi % D'100'
		
		BZ	$ + 8

		NOP		;<--------------------------------------;
		DECFSZ	WREG						;
		DB	0xFD,0xD7 ;BRA	-3	;-----------------------;
		POP
		endif

		if Microsecondi < D'101'
		MOVLW	Microsecondi
		CLRWDT		;<--------------------------------------;
		DECFSZ	WREG						;
		DB	0xFD,0xD7 ;BRA	-3	;-----------------------;
		endif
		
		endm


DelayMilliSec	macro	Time2

		ifdef	FREQUENCY
		Millisecondi = ((Time2 * FREQUENCY)/.16000)
		endif

		if Millisecondi > .100
		PUSH
		MOVLW	Millisecondi / .100		
		MOVWF	TOSH	
		MOVLW	.100	;<--------------------------------------;
		MOVWF	TOSL						;
		MOVLW	.250	;<------------------------------;	;					;
		CLRWDT		;<----------------------;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		NOP					;	;	;
		DECFSZ	WREG				;	;	;
		DB	0xF1,0xD7 ;BRA	-.15	;-------;	;	;
		DECFSZ	TOSL					;	;
		DB	0xEE,0xD7 ;BRA	-.18	;---------------;	;
		DECFSZ	TOSH						;
		DB	0xEA,0xD7 ;BRA	-.22	;-----------------------;

		MOVLW	Millisecondi % .100
		MOVWF	TOSL
		MOVLW	.250	;<------------------------------;
		CLRWDT		;<----------------------;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		DECFSZ	WREG				;	;
		DB	0xF1,0xD7 ;BRA	-.15	;-------;	;
		DECFSZ	TOSL					;
		DB	0xEE,0xD7 ;BRA	-.18	;---------------;
		POP
		endif

	if Millisecondi < .101
		PUSH
		MOVLW	Millisecondi
		MOVWF	TOSL
		MOVLW	.250	;<------------------------------;					;
		NOP		;<----------------------;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		NOP					;	;
		DECFSZ	WREG				;	;
		DB	0xF1,0xD7 ;BRA	-.15	;-------;	;
		DECFSZ	TOSL					;
		DB	0xEE,0xD7 ;BRA	-.18	;---------------;
		POP
		endif
		endm

#DEFINE MILLISECONDI	DelayMilliSec 
#DEFINE MICROSECONDI	DelayMicroSec 
