;********************************************************************************************
;
;	ROUTINES PER EFFETTUARE UN CONTROLLO A LOOP CHIUSO BASATO SU
;	APPROSSIMAZIONI SUCCESSIVE (IN BASE 2) SPECIFICHE PER "PIC18FXXX"
;	VERSIONE A 16 BIT!
;	Versione 1.0		     		Ult.agg. 03/11/03
;
;********************************************************************************************

;********************************************************************************************
;
;	NOTA! IL TEMPO DI AGIORNAMENTO DEVE ESSERE ABBASTANZA LUNGO DA PERMETTERE 
;	L'AGGIORNAMENTO AL SISTEMA! (ESEMPIO FEED-BACK DI POMPE!) 
;	RICHIESTE ROUTINE MATEMATICHE AVANZATE!!!	
;********************************************************************************************

;------ REGISTRI DA DEFINIRE NEL MAIN PROGRAM!  ---------------------------------------------;
;	TEMP_LOOP, TEMP_LOOP_H, TEMP_THR_L, TEMP_THR_H, STATUS_LOOP, IN_REG_L, IN_REG_H
;	OUT_REG_L, OUT_REG_H, THRESHOLD_L, THRESHOLD_H, DELTA_MAX_L, DELTA_MAX_H
;
;	TEMP_LOOP	EQU ...			; MASCHERA PER L'INCREMENTO
;	TEMP_LOOP_H	EQU ...			;
;	TEMP_THR_L	EQU ...			; SOGLIA TEMPORANEA CON DELTA
;	TEMP_THR_H	EQU ...			;
;	STATUS_LOOP	EQU ...			; REGISTRO DI STATO DEL LOOP
;	IN_REG_L	EQU ...			; 
;	IN_REG_H	EQU ...			; VALORE IN ENTRATA DA COMPARARE CON THRESHOLD
;	OUT_REG_L	EQU ...			; VALORE IN USCITA (IL VALORE E' USATO COME INPUT
;	OUT_REG_H	EQU ...			; ALLA CHIAMATA DELLA ROUTINE E COME OUTPUT IN USCITA)
;	THRESHOLD_L	EQU ...			; VALORE DA COMPARARE CON IN_REG_x
;	THRESHOLD_H	EQU ...			;
;	DELTA_MAX_L	EQU ...			; SCARTO MASSIMO ACCETTABILE (PUO' ESSERE ANCHE 0)
;	DELTA_MAX_H	EQU ...			; 


#DEFINE	START_THRESHOLD	D'512'
#DEFINE	START_DELTA_MAX	D'100'

#DEFINE	START_INCR_LOOP_H B'00000000'		;
#DEFINE	START_INCR_LOOP_L B'00000001'		; VALORE DELL'INCREMENTO ALLA PARTENZA

#DEFINE	MAX_INC_H	B'00000000'		; MASSIMO VALORE CHE PUO' ASSUMERE L'INCREMENTO
#DEFINE	MAX_INC_L	B'10000000'		;

#DEFINE	MIN_INC_H	B'00000000'		; MINIMO VALORE CHE PUO' ASSUMERE IL DECREMENTO
#DEFINE	MIN_INC_L	B'00000001'		;

#DEFINE	OVRFLW		STATUS_LOOP, 0		;
#DEFINE	UNDFLW		STATUS_LOOP, 1		;
#DEFINE	LOCKED		STATUS_LOOP, 2		;
#DEFINE	_INIT		STATUS_LOOP, 3		; SE = 0 E' ALL'INIZIO (E USO IL START_INCR_LOOP_x)
#DEFINE	LAST		STATUS_LOOP, 4		; SE = 0 NELL'ULTIMO PASSAGGIO IL VALORE ERA MINORE
#DEFINE NC_2ND_TIME	STATUS_LOOP, 5		; SETTATO = 1 DOPO IL PRIMO "NON CAMBIO DI DIREZIONE"
#DEFINE NC_3ND_TIME	STATUS_LOOP, 6		; SETTATO = 1 DOPO IL SECONDO "NON CAMBIO DI DIREZIONE"
#DEFINE INVERS_LOOP	STATUS_LOOP, 7		; SE = 1 LA RETROAZIONE DIVENTA NEGATIVA (SCAMBIO INCREMENTO CON DECREMENTO)

#DEFINE	START_THRESHOLD_L 	LOW START_THRESHOLD
#DEFINE	START_THRESHOLD_H	HIGH START_THRESHOLD
#DEFINE	START_DELTA_MAX_L	LOW START_DELTA_MAX
#DEFINE	START_DELTA_MAX_H	HIGH START_DELTA_MAX

;---------------------------------------

INIT_LOOP
	CLRF	TEMP_LOOP
	CLRF	TEMP_LOOP_H
	CLRF	STATUS_LOOP
	CLRF	IN_REG_L
	CLRF	IN_REG_H
	CLRF	OUT_REG_L
	CLRF	OUT_REG_H
	
	MOVLW	START_THRESHOLD_L	; DEVONO ESSERE DEFINITE DAL GENTILE UTENTE!
	MOVWF	THRESHOLD_L		; 
	MOVLW	START_THRESHOLD_H	;
	MOVWF	THRESHOLD_H		; 
	MOVLW	START_DELTA_MAX_L	;
	MOVWF	DELTA_MAX_L		;
	MOVLW	START_DELTA_MAX_H	;
	MOVWF	DELTA_MAX_H		;
	RETURN

;---------------------------------------

LOOP_UPDATE				;
	MOVLW	START_INCR_LOOP_L	; SE E' IL PRIMO GIRO INIZIALIZZO IL REGISTRO DI INCREMENTO
	BTFSS	_INIT			;
	MOVWF	TEMP_LOOP		;
	MOVLW	START_INCR_LOOP_H	;< SE E' IL PRIMO GIRO INIZIALIZZO IL REGISTRO DI INCREMENTO
	BTFSS	_INIT			;<
	MOVWF	TEMP_LOOP_H		;<
	BSF	_INIT			;<
	
COMPARE					;

	MOVF	DELTA_MAX_L, W		;
	ADDWF	THRESHOLD_L, W		;
	MOVWF	TEMP_THR_L		;
	MOVF	DELTA_MAX_H, W		;
	ADDWFC	THRESHOLD_H, W		;
	MOVWF	TEMP_THR_H		;
	BTFSC	STATUS, C		; SE IL RISULTATO E' MAGGIORE DI 0xFF LO RIPORTO A 0xFF
	SETF	TEMP_THR_L		; 
	BTFSC	STATUS, C		; 
	SETF	TEMP_THR_H		; IN "TEMP_THR_x" C'E' LA SOMMA  "THRESHOLD + DELATA_MAX" (LIMITATA A 0xFFFF)

	; SE IN_REG > TH+D ALLORA GOTO DECREMENTO 
	COMP_N_MAG IN_REG_H, IN_REG_L, TEMP_THR_H, TEMP_THR_L
	GOTO	DECREMENTO

	MOVF	DELTA_MAX_L, W		;
	SUBWF	THRESHOLD_L, W		;
	MOVWF	TEMP_THR_L		;
	MOVF	DELTA_MAX_H, W		;
	SUBWFB	THRESHOLD_H, W		;
	MOVWF	TEMP_THR_H		;
	BTFSS	STATUS, C		; SE IL RISULTATO E' MINORE DI 0 LO RIPORTO A 0 
	CLRF	TEMP_THR_L		;
	BTFSS	STATUS, C		;
	CLRF	TEMP_THR_H		; IN "TEMP_THR_x" C'E' LA DIFFERENZA  "THRESHOLD - DELATA_MAX" (LIMITATA AI VALORI NON NEGATIVI)

	; SE IN_REG < TH+D ALLORA GOTO INCREMENTO 
	COMP_N_MIN IN_REG_H, IN_REG_L, TEMP_THR_H, TEMP_THR_L
	GOTO	INCREMENTO
	
	BSF	LOCKED			; SE SI ARRIVA QUI IL VALORE RIENTRA NEL RANGE
					; E DUNQUE OUT_REG E' GIUSTO
	BCF	NC_2ND_TIME		; DEVO RESETTARE SENNO ALLA PROSSIMA RADDOPPIO DIRETTAMENTE
	BCF	NC_3ND_TIME		;
	RETURN				;

;---------------------------------------

INCREMENTO				;
	BTFSC	INVERS_LOOP		;
	GOTO	DECREMENTO_II		;
INCREMENTO_II				;
	MOVLW	MIN_INC_L		;<
	BTFSC	LOCKED			;<
	MOVWF	TEMP_LOOP		;<
	BTFSC	LOCKED			;<
	MOVLW	MIN_INC_H		;<
	BTFSC	LOCKED			;<
	MOVWF	TEMP_LOOP_H		;<
	BTFSC	LOCKED			;
	GOTO	INCR_UPD		;
					;
	BTFSS	LAST			;
	GOTO	NO_CHNG_INC		;
					;
CH_DIR_INC				;
	BCF	NC_2ND_TIME		; CAMBIO DI DIREZIONE, RESETTO I BIT CORRISPONDENTE
	BCF	NC_3ND_TIME		;

	COMPW_N_EQU TEMP_LOOP_H, TEMP_LOOP, MIN_INC_H, MIN_INC_L ; SE TEMP_LOOP_x = MIN_INC_x CI RESTA
	GOTO	INCR_UPD		;

	BCF	STATUS, C		;
	RRCF	TEMP_LOOP_H, F		; DIMEZZO TEMP_LOOP_x
	RRCF	TEMP_LOOP, F		;
	GOTO	INCR_UPD		;
					;

NO_CHNG_INC				;

	BTFSS	NC_2ND_TIME		; 
	GOTO	INCR_UPD_1ST_TIME	; SE E' LA PRIMA VOLTA

	BTFSS	NC_3ND_TIME		;;; 
	GOTO	INCR_UPD_2ST_TIME	;;; SE E' LA SECONDA VOLTA

					;
	BCF	NC_2ND_TIME		; DEVO RESETTARE SENNO ALLA PROSSIMA RADDOPPIO DIRETTAMENTE
	BCF	NC_3ND_TIME		;;;;

	COMPW_N_EQU TEMP_LOOP_H, TEMP_LOOP, MAX_INC_H, MAX_INC_L ; SE TEMP_LOOP_x = MAX_INC_x CI RESTA
	GOTO	INCR_UPD		;

	BCF	STATUS, C		;
	RLCF	TEMP_LOOP, F		;
	RLCF	TEMP_LOOP_H, F		; SE LA DIREZIONE NON E' CAMBIATA (PER 2 VOLTE)RADDOPPIO TEMP_LOOP
	GOTO	INCR_UPD		;
					;
INCR_UPD_2ST_TIME			;;;;
	BSF	NC_3ND_TIME		;;;; SETTO IL BIT PER RADDOPPIARE ALLA PROSSIMA
INCR_UPD_1ST_TIME			;
	BSF	NC_2ND_TIME		; SETTO IL BIT PER RADDOPPIARE FRA DUE VOLTE
INCR_UPD				;
	BCF	OVRFLW			;

	MOVF	TEMP_LOOP, W		;<
	ADDWF	OUT_REG_L, F		;<
	MOVF	TEMP_LOOP_H, W		;<
	ADDWFC	OUT_REG_H, F		;< OUT_REG = OUT_REG + TEMP_LOOP

	BTFSC	STATUS, C		; IF OUT_REG > 0xFF LO RIDIMENSIONO ... 
	BSF	OVRFLW			; ... E SETTO OVERFLOW
	BTFSC	STATUS, C		;< 
	SETF	OUT_REG_L		;<
	BTFSC	STATUS, C		;<
	SETF	OUT_REG_H		;<
					;
	BCF	LOCKED			; SETTO I BIT GIUSTI 
	BCF	LAST			; 
	RETURN				;

;---------------------------------------

DECREMENTO				;
	BTFSC	INVERS_LOOP		;
	GOTO	INCREMENTO_II		;
DECREMENTO_II				;
	MOVLW	MIN_INC_L		;<
	BTFSC	LOCKED			;<
	MOVWF	TEMP_LOOP		;<
	BTFSC	LOCKED			;<
	MOVLW	MIN_INC_H		;<
	BTFSC	LOCKED			;<
	MOVWF	TEMP_LOOP_H		;<
	BTFSC	LOCKED			;
	GOTO	DECR_UPD		;
					;
	BTFSC	LAST			;
	GOTO	NO_CHNG_DEC		;
					;
CH_DIR_DEC				;
	BCF	NC_2ND_TIME		; CAMBIO DI DIREZIONE, RESETTO I BIT CORRISPONDENTE
	BCF	NC_3ND_TIME		;

	COMPW_N_EQU TEMP_LOOP_H, TEMP_LOOP, MIN_INC_H, MIN_INC_L ; SE TEMP_LOOP_x = MIN_INC_x CI RESTA
	GOTO	DECR_UPD		;

	BCF	STATUS, C		;
	RRCF	TEMP_LOOP_H, F		; DIMEZZO TEMP_LOOP_x
	RRCF	TEMP_LOOP, F		;
	GOTO	DECR_UPD		;
					;
NO_CHNG_DEC				;
	BTFSS	NC_2ND_TIME		; SE E' LA PRIMA VOLTA
	GOTO	DECR_UPD_1ST_TIME	;
	BTFSS	NC_3ND_TIME		;;; 
	GOTO	DECR_UPD_2ST_TIME	;;; SE E' LA SECONDA VOLTA
					;
	BCF	NC_2ND_TIME		; DEVO RESETTARE SENNO ALLA PROSSIMA RADDOPPIO DIRETTAMENTE
	BCF	NC_3ND_TIME		;;;;

	COMPW_N_EQU TEMP_LOOP_H, TEMP_LOOP, MAX_INC_H, MAX_INC_L ; SE TEMP_LOOP_x = MAX_INC_x CI RESTA
	GOTO	DECR_UPD		;

	BCF	STATUS, C		;
	RLCF	TEMP_LOOP, F		;
	RLCF	TEMP_LOOP_H, F		; SE LA DIREZIONE NON E' CAMBIATA (PER 2 VOLTE)RADDOPPIO TEMP_LOOP
	GOTO	DECR_UPD		;
					;
DECR_UPD_2ST_TIME			;;;;
	BSF	NC_3ND_TIME		;;;; SETTO IL BIT PER RADDOPPIARE ALLA PROSSIMA
DECR_UPD_1ST_TIME			;
	BSF	NC_2ND_TIME		; SETTO IL BIT PER RADDOPPIARE FRA DUE
DECR_UPD				;
	BCF	UNDFLW			;
	MOVF	TEMP_LOOP, W		;
	SUBWF	OUT_REG_L, F		;
	MOVF	TEMP_LOOP_H, W		;
	SUBWFB	OUT_REG_H, F		; OUT_REG_x = OUT_REG_x - TEMP_LOOP_x
	BTFSS	STATUS, C		; IF OUT_REG E' NEGATIVO LO PORTO A ZERO ... 
	BSF	UNDFLW			; ... E SETTO UNDERFLOW
	BTFSS	STATUS, C		; 
	CLRF	OUT_REG_L		;
	BTFSS	STATUS, C		; 
	CLRF	OUT_REG_H		;
					;
	BCF	LOCKED			; SETTO I BIT GIUSTI 
	BSF	LAST			; 
	RETURN				;
	
;---------------------------------------
